SynthComboBoxUI (Java Platform SE 8 )
Keywords: javax.swing.plaf.synth.SynthComboBoxUI class
Date: 2018-07-01

javax.swing.plaf.synth

## Class SynthComboBoxUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.ComboBoxUI
    - - javax.swing.plaf.basic.BasicComboBoxUI
      - - javax.swing.plaf.synth.SynthComboBoxUI

- All Implemented Interfaces:
    PropertyChangeListener, EventListener, SynthConstants, SynthUI

      public class SynthComboBoxUI
      extends BasicComboBoxUI
      implements PropertyChangeListener, SynthUI

  Provides the Synth L&F UI delegate for `JComboBox`.
  Since:
    1.7

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.plaf.basic.BasicComboBoxUI

      `BasicComboBoxUI.ComboBoxLayoutManager, BasicComboBoxUI.FocusHandler, BasicComboBoxUI.ItemHandler, BasicComboBoxUI.KeyHandler, BasicComboBoxUI.ListDataHandler, BasicComboBoxUI.PropertyChangeHandler`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.plaf.basic.BasicComboBoxUI

      `arrowButton, cachedMinimumSize, comboBox, currentValuePane, editor, focusListener, hasFocus, isMinimumSizeDirty, itemListener, keyListener, listBox, listDataListener, padding, popup, popupKeyListener, popupMouseListener, popupMouseMotionListener, propertyChangeListener, squareButton`

    - ### Fields inherited from interface javax.swing.plaf.synth.SynthConstants

      `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SynthComboBoxUI()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JButton` | `createArrowButton()` Creates a button which will be used as the control to show or hide the popup portion of the combo box.
    `protected ComboBoxEditor` | `createEditor()` Creates the default editor that will be used in editable combo boxes.
    `protected ComboPopup` | `createPopup()` Creates the popup portion of the combo box.
    `protected ListCellRenderer` | `createRenderer()` Creates the default renderer that will be used in a non-editiable combo box.
    `static ComponentUI` | `createUI(JComponent c)` Creates a new UI object for the given component.
    `SynthContext` | `getContext(JComponent c)` Returns the Context for the specified component.
    `protected Dimension` | `getDefaultSize()` Returns the default size of an empty display area of the combo box using the current renderer and font.
    `protected void` | `installDefaults()` Installs the default colors, default font, default renderer, and default editor into the JComboBox.
    `protected void` | `installListeners()` Creates and installs listeners for the combo box and its model.
    `void` | `installUI(JComponent c)` Configures the specified component appropriately for the look and feel.
    `void` | `paint(Graphics g, JComponent c)` Paints the specified component according to the Look and Feel.
    `protected void` | `paint(SynthContext context, Graphics g)` Paints the specified component.
    `void` | `paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)` Paints the border.
    `void` | `paintCurrentValue(Graphics g, Rectangle bounds, boolean hasFocus)` Paints the currently selected item.
    `void` | `propertyChange(PropertyChangeEvent e)` This method gets called when a bound property is changed.
    `protected void` | `uninstallDefaults()` Uninstalls the default colors, default font, default renderer, and default editor from the combo box.
    `protected void` | `uninstallListeners()` Removes the installed listeners from the combo box and its model.
    `void` | `uninstallUI(JComponent c)` Reverses configuration which was done on the specified component during `installUI`.
    `void` | `update(Graphics g, JComponent c)` Notifies this UI delegate to repaint the specified component.

    - ### Methods inherited from class javax.swing.plaf.basic.BasicComboBoxUI

      `addEditor, configureArrowButton, configureEditor, createFocusListener, createItemListener, createKeyListener, createLayoutManager, createListDataListener, createPropertyChangeListener, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getDisplaySize, getInsets, getMaximumSize, getMinimumSize, getPreferredSize, getSizeForComponent, installComponents, installKeyboardActions, isFocusTraversable, isNavigationKey, isPopupVisible, paintCurrentValueBackground, rectangleForCurrentValue, removeEditor, selectNextPossibleValue, selectPreviousPossibleValue, setPopupVisible, toggleOpenClose, unconfigureArrowButton, unconfigureEditor, uninstallComponents, uninstallKeyboardActions`

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SynthComboBoxUI

          public SynthComboBoxUI()

  - ### Method Detail

    - #### createUI

          public static ComponentUI createUI(JComponent c)

      Creates a new UI object for the given component.
      Parameters:
        `c` - component to create UI object for
      Returns:
        the UI object

    - #### installUI

          public void installUI(JComponent c)

      Configures the specified component appropriately for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
      1. Install default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
      2. Install a `LayoutManager` on the component if necessary.
      3. Create/add any required sub-components to the component.
      4. Create/install event listeners on the component.
      5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
      6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
      7. Initialize any appropriate instance data.
      Overridden to ensure that ButtonHandler is created prior to any of the other installXXX methods, since several of them reference buttonHandler.
      Overrides:
        `installUI` in class `BasicComboBoxUI`
      Parameters:
        `c` - the component where this UI delegate is being installed
      See Also:
        `ComponentUI.uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

    - #### installDefaults

          protected void installDefaults()

      Description copied from class: `BasicComboBoxUI`
      Installs the default colors, default font, default renderer, and default editor into the JComboBox.
      Overrides:
        `installDefaults` in class `BasicComboBoxUI`

    - #### installListeners

          protected void installListeners()

      Creates and installs listeners for the combo box and its model. This method is called when the UI is installed.
      Overrides:
        `installListeners` in class `BasicComboBoxUI`

    - #### uninstallUI

          public void uninstallUI(JComponent c)

      Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
      1. Remove any UI-set borders from the component.
      2. Remove any UI-set layout managers on the component.
      3. Remove any UI-added sub-components from the component.
      4. Remove any UI-added event/property listeners from the component.
      5. Remove any UI-installed keyboard UI from the component.
      6. Nullify any allocated instance data objects to allow for GC.
      Overrides:
        `uninstallUI` in class `BasicComboBoxUI`
      Parameters:
        `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

    - #### uninstallDefaults

          protected void uninstallDefaults()

      Uninstalls the default colors, default font, default renderer, and default editor from the combo box.
      Overrides:
        `uninstallDefaults` in class `BasicComboBoxUI`

    - #### uninstallListeners

          protected void uninstallListeners()

      Removes the installed listeners from the combo box and its model. The number and types of listeners removed and in this method should be the same that was added in `installListeners`
      Overrides:
        `uninstallListeners` in class `BasicComboBoxUI`

    - #### getContext

          public SynthContext getContext(JComponent c)

      Returns the Context for the specified component.
      Specified by:
        `getContext` in interface `SynthUI`
      Parameters:
        `c` - Component requesting SynthContext.
      Returns:
        SynthContext describing component.

    - #### createPopup

          protected ComboPopup createPopup()

      Creates the popup portion of the combo box.
      Overrides:
        `createPopup` in class `BasicComboBoxUI`
      Returns:
        an instance of `ComboPopup`
      See Also:
        `ComboPopup`

    - #### createRenderer

          protected ListCellRenderer createRenderer()

      Creates the default renderer that will be used in a non-editiable combo box. A default renderer will used only if a renderer has not been explicitly set with `setRenderer`.
      Overrides:
        `createRenderer` in class `BasicComboBoxUI`
      Returns:
        a `ListCellRender` used for the combo box
      See Also:
        `JComboBox.setRenderer(javax.swing.ListCellRenderer<? super E>)`

    - #### createEditor

          protected ComboBoxEditor createEditor()

      Creates the default editor that will be used in editable combo boxes. A default editor will be used only if an editor has not been explicitly set with `setEditor`.
      Overrides:
        `createEditor` in class `BasicComboBoxUI`
      Returns:
        a `ComboBoxEditor` used for the combo box
      See Also:
        `JComboBox.setEditor(javax.swing.ComboBoxEditor)`

    - #### propertyChange

          public void propertyChange(PropertyChangeEvent e)

      This method gets called when a bound property is changed.
      Specified by:
        `propertyChange` in interface `PropertyChangeListener`
      Parameters:
        `e` - A PropertyChangeEvent object describing the event source and the property that has changed.

    - #### createArrowButton

          protected JButton createArrowButton()

      Creates a button which will be used as the control to show or hide the popup portion of the combo box.
      Overrides:
        `createArrowButton` in class `BasicComboBoxUI`
      Returns:
        a button which represents the popup control

    - #### update

          public void update(Graphics g,
                             JComponent c)

      Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

      In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

      Overrides:
        `update` in class `ComponentUI`
      Parameters:
        `g` - the `Graphics` object used for painting
        `c` - the component being painted
      See Also:
        `paint(SynthContext,Graphics)`

    - #### paint

          public void paint(Graphics g,
                            JComponent c)

      Paints the specified component according to the Look and Feel.

      This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

      Overrides:
        `paint` in class `BasicComboBoxUI`
      Parameters:
        `g` - the `Graphics` object used for painting
        `c` - the component being painted
      See Also:
        `paint(SynthContext,Graphics)`

    - #### paint

          protected void paint(SynthContext context,
                               Graphics g)

      Paints the specified component.
      Parameters:
        `context` - context for the component being painted
        `g` - the `Graphics` object used for painting
      See Also:
        `update(Graphics,JComponent)`

    - #### paintBorder

          public void paintBorder(SynthContext context,
                                  Graphics g,
                                  int x,
                                  int y,
                                  int w,
                                  int h)

      Paints the border.
      Specified by:
        `paintBorder` in interface `SynthUI`
      Parameters:
        `context` - a component context
        `g` - `Graphics` to paint on
        `x` - the X coordinate
        `y` - the Y coordinate
        `w` - width of the border
        `h` - height of the border

    - #### paintCurrentValue

          public void paintCurrentValue(Graphics g,
                                        Rectangle bounds,
                                        boolean hasFocus)

      Paints the currently selected item.
      Overrides:
        `paintCurrentValue` in class `BasicComboBoxUI`

    - #### getDefaultSize

          protected Dimension getDefaultSize()

      Returns the default size of an empty display area of the combo box using the current renderer and font. This method was overridden to use SynthComboBoxRenderer instead of DefaultListCellRenderer as the default renderer when calculating the size of the combo box. This is used in the case of the combo not having any data.
      Overrides:
        `getDefaultSize` in class `BasicComboBoxUI`
      Returns:
        the size of an empty display area
      See Also:
        `BasicComboBoxUI.getDisplaySize()`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2018, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.